//*************************************************
//
// main.c
// esempio di scomposizione e ricomposizione di un numero
// a 16 bit
// autore: Bernardo Giovanni (www.settorezero.com)
// data: 06/01/2010
//
//*************************************************
#define  XTAL_FREQ 20MHZ
#include <pic.h>

__CONFIG (HS & WDTDIS & PWRTEN & BORDIS & LVPDIS & DUNPROT & WRTEN & DEBUGDIS & UNPROTECT);

#include "settings.h"
#include "delay.c"
#include "lcd.c"

void main(void)
        {
		settings(); // imposto le porte
		LCD_INIT(); // inizializzo l'LCD
		DelayMs(100); // piccolo ritardo iniziale
		LCD_CLEAR(); // ripulisco il display

		// numero di esempio a 16 bit
		unsigned int numero = 21277;
		
		// scompongo il numero in due byte
		// il byte basso (BL) sono gli 8 bit pi a destra del valore a 16 bit
		// il byte alto (BH) sono gli 8 bit pi a sinistra del valore a 16 bit
		// anche se BH e BL sono valori ad 8 bit, li devo comunque definire come se fossero a 16 bit
		// altrimenti non posso effettuarvi le operazioni logiche
		unsigned int BH;
		unsigned int BL;
		
		BH = numero >> 8; // sposto il valore di 8 bit a destra
		BL = numero & 0xFF; // metto a zero gli 8 bit pi a sinistra

		// scrivo sul display i valori di BH e di BL
		LCD_PUTS("BL:");
		LCD_PUTUN(BL);
		LCD_PUTS(" BH:");
		LCD_PUTUN(BH);
		
		// ricompongo il numero a 16 bit partendo dai due valori BL e BH
		unsigned int numero_ricomposto = 0;
		
		numero_ricomposto = BL | (BH<<8);
		
		// altro metodo per ricomporre il numero
		//numero_ricomposto = BL + (BH*256);
		
		// scrivo il valore ricomposto sul display
		LCD_GOTO(2,1);
		LCD_PUTS("Numero:");
		LCD_PUTUN(numero_ricomposto);
	
		while(1)
			{
			}
			
	}